<ng-container *ngIf="dispatchView; else dataAwaitedBlk" [formGroup]="step1FormGroup">
  <div class="e-bg-eblue250 eh-mt-16 eh-p-8" fxLayout="row" fxLayoutAlign="start center">
    <mat-icon class="e-mat-icon e-mat-icon--2 eh-mr-8 e-txt-eblue700">contacts</mat-icon>
    <span class="e-txt-eblue700">Basic</span>
  </div>
  <div class="eh-mt-16" fxLayout="row" formGroupName="personalDetails">
    <div fxFlex="0 0 50%">
      <div fxLayout="row">
        <div class="eh-ml-8">
          <mat-form-field appearance="standard" class="e-mat-form-field e-mat-form-field--2">
            <mat-label>First Name<sup>*</sup></mat-label>
            <input matInput formControlName="firstName">
          </mat-form-field>
        </div>
        <div class="eh-ml-20">
          <mat-form-field appearance="standard" class="e-mat-form-field e-mat-form-field--2">
            <mat-label>Last Name<sup>*</sup></mat-label>
            <input matInput formControlName="lastName">
          </mat-form-field>
        </div>
      </div>
      <div fxLayout="row" fxLayoutAlign="start end">
        <div class="eh-ml-8">
          <mat-form-field appearance="standard" class="e-mat-form-field e-mat-form-field--2">
            <mat-label>Date of Birth<sup>*</sup></mat-label>
            <input matInput readonly [matDatepicker]="picker" [max]="maxDate" [value]="dob"
              (dateInput)="onDOBSet($event)">
            <mat-datepicker-toggle matSuffix [for]="picker" class="e-mat-datepicker"></mat-datepicker-toggle>
            <mat-datepicker #picker></mat-datepicker>
          </mat-form-field>
        </div>
        <div class="eh-ml-20" fxLayout="column">
          <span class="eh-txt-12 eh-mb-4">Gender<sup>*</sup></span>
          <div style="padding-bottom: 1.34375em;">
            <mat-button-toggle-group class="e-mat-button-toggle" formControlName="gender">
              <mat-button-toggle [checked]="gender === genderTypes.MALE" [value]="genderTypes.MALE">
                Male
              </mat-button-toggle>
              <mat-button-toggle [checked]="gender === genderTypes.FEMALE" [value]="genderTypes.FEMALE">
                Female
              </mat-button-toggle>
            </mat-button-toggle-group>
          </div>
        </div>
      </div>
    </div>
    <div fxFlex="0 0 50%">
      <div class="eh-w-300">
        <div>Profile Picture</div>
        <app-input-file-preview [uploadByName]="me.name" [uploadByUID]="me.uid"
          [uploadCollectionName]="uploadCollectionName" [uploadDirPath]="uploadDirPath"
          [uploadFileNamePrefix]="uploadFileNamePrefix" [userMembershipKey]="me.membershipKey" [userUID]="me.uid"
          (availableEvent)="availableEvent($event)" (uploadEvent)="uploadEvent($event)">
        </app-input-file-preview>
      </div>
    </div>
  </div>
  <div class="e-bg-eblue250 eh-mt-16 eh-p-8" fxLayout="row" fxLayoutAlign="start center">
    <mat-icon class="e-mat-icon e-mat-icon--2 eh-mr-8 e-txt-eblue700">contact_mail</mat-icon>
    <span class="e-txt-eblue700">Contact</span>
  </div>
  <div class="eh-mt-16" fxLayout="row" formGroupName="personalDetails">
    <div fxFlex="0 0 50%">
      <div fxLayout="row">
        <div class="eh-ml-8 eh-w-300">
          <mat-form-field appearance="standard" class="e-mat-form-field e-mat-form-field--full-width">
            <mat-label>Address Line 1<sup>*</sup></mat-label>
            <input matInput formControlName="addressLine1">
          </mat-form-field>
        </div>
      </div>
      <div fxLayout="row">
        <div class="eh-ml-8 eh-w-300">
          <mat-form-field appearance="standard" class="e-mat-form-field e-mat-form-field--full-width">
            <mat-label>Address Line 2</mat-label>
            <input matInput formControlName="addressLine2">
          </mat-form-field>
        </div>
      </div>
      <div fxLayout="row">
        <div class="eh-ml-8">
          <mat-form-field appearance="standard" class="e-mat-form-field e-mat-form-field--2">
            <mat-label>City<sup>*</sup></mat-label>
            <input matInput formControlName="city">
          </mat-form-field>
        </div>
        <div class="eh-ml-20">
          <mat-form-field appearance="standard" class="e-mat-form-field e-mat-form-field--2">
            <mat-label>Pincode<sup>*</sup></mat-label>
            <input matInput formControlName="pincode">
          </mat-form-field>
        </div>
      </div>
      <div fxLayout="row">
        <div class="eh-ml-8">
          <mat-form-field appearance="standard" class="e-mat-form-field e-mat-form-field--2">
            <mat-label>State<sup>*</sup></mat-label>
            <input matInput formControlName="state">
          </mat-form-field>
        </div>
        <div class="eh-ml-20">
          <mat-form-field appearance="standard" class="e-mat-form-field e-mat-form-field--2">
            <mat-label>Country<sup>*</sup></mat-label>
            <input matInput formControlName="country">
          </mat-form-field>
        </div>
      </div>
    </div>
    <div fxFlex="0 0 50%">
      <div fxLayout="row">
        <div class="eh-ml-8">
          <mat-form-field appearance="standard" class="e-mat-form-field e-mat-form-field--2">
            <mat-label>Mobile Phone<sup>*</sup></mat-label>
            <input matInput formControlName="mobile">
            <mat-hint>+91-XXXXXXXXXX</mat-hint>
          </mat-form-field>
        </div>
      </div>
      <div class="eh-mt-16" fxLayout="row">
        <div class="eh-ml-8 eh-w-300">
          <mat-form-field appearance="standard" class="e-mat-form-field e-mat-form-field--full-width">
            <mat-label>Email<sup>*</sup></mat-label>
            <input matInput readonly formControlName="email">
          </mat-form-field>
        </div>
      </div>
    </div>
  </div>
  <div class="e-bg-eblue250 eh-mt-16 eh-p-8" fxLayout="row" fxLayoutAlign="start center">
    <mat-icon class="e-mat-icon e-mat-icon--2 eh-mr-8 e-txt-eblue700">tune</mat-icon>
    <span class="e-txt-eblue700">Preferences</span>
  </div>
  <div class="eh-mt-16" fxLayout="row" formGroupName="personalDetails">
    <div fxFlex="0 0 50%">
      <div fxLayout="row">
        <div class="eh-ml-8 eh-w-300">
          <div>Category<sup>*</sup></div>
          <div class="eh-px-8" fxLayout="row wrap" fxLayoutAlign="space-between center">
            <mat-radio-group class="e-mat-radio-group" fxLayout="row wrap" fxLayoutAlign="space-between center"
              formControlName="category" (change)="setSubCategories()">
              <mat-radio-button class="eh-mt-8" *ngFor="let c of categories" [value]="c" fxFlex="0 0 60%">{{c}}
              </mat-radio-button>
            </mat-radio-group>
          </div>
        </div>
      </div>
    </div>
    <div fxFlex="0 0 50%">
      <div fxLayout="row">
        <div *ngIf="categoryFC.value" class="eh-ml-8 eh-w-100p">
          <div>Service Type<sup>*</sup></div>
          <div class="eh-px-8">
            <mat-radio-group class="e-mat-radio-group" fxLayout="row wrap" fxLayoutAlign="space-between center"
              formControlName="serviceType">
              <mat-radio-button class="eh-mt-8" *ngFor="let s of subCategories" fxFlex="0 0 50%" [value]="s">{{s}}
              </mat-radio-button>
            </mat-radio-group>
          </div>
        </div>
      </div>
    </div>
  </div>
  <div class="eh-mt-24" fxLayout="row" formGroupName="personalDetails">
    <div fxFlex="0 0 50%">
      <div fxLayout="row">
        <div class="eh-ml-8 eh-w-300">
          <div>Preferred Location<sup>*</sup></div>
          <div class="eh-px-8" fxLayout="row wrap" fxLayoutAlign="space-between center">
            <mat-radio-group class="e-mat-radio-group" fxLayout="row wrap" fxLayoutAlign="space-between center"
              formControlName="preferredLocation">
              <mat-radio-button class="eh-mt-8" *ngFor="let l of locations" fxFlex="0 0 50%" [value]="l"
                [checked]="isPreferredLocationChecked(l)">{{l.name}}
              </mat-radio-button>
            </mat-radio-group>
          </div>
        </div>
      </div>
    </div>
    <div fxFlex="0 0 50%">
      <div fxLayout="row" fxLayoutAlign="start start">
        <div class="eh-ml-8 eh-w-100p">
          <div>Target</div>
          <div fxLayout="row" fxLayoutAlign="space-between center">
            <mat-form-field class="eh-w-100p">
              <textarea matInput cdkTextareaAutosize cdkAutosizeMinRows="5" formControlName="target" maxLength="50"
                #message></textarea>
              <mat-hint align="end">{{message.value.length}} / 50</mat-hint>
            </mat-form-field>
          </div>
        </div>
      </div>
    </div>
  </div>
  <div class="e-bg-eblue250 eh-mt-16 eh-p-8" fxLayout="row" fxLayoutAlign="start center">
    <mat-icon class="e-mat-icon e-mat-icon--2 eh-mr-8 e-txt-eblue700">contacts</mat-icon>
    <span class="e-txt-eblue700">Referral</span>
  </div>
  <div class="eh-mt-16" fxLayout="row" formGroupName="personalDetails">
    <div class="eh-ml-8" fxFlex="0 0 50%">
      <mat-form-field appearance="standard" class="e-mat-form-field e-mat-form-field--full-width">
        <mat-label>Referred by (name/email/mobile)</mat-label>
        <input matInput formControlName="referredBy">
      </mat-form-field>
    </div>
  </div>
  <div class="eh-mt-20">
    <mat-divider></mat-divider>
  </div>
  <div class="eh-mt-20" fxLayout="row" fxLayoutAlign="space-between start">
    <button mat-stroked-button (click)="onSubscribeLater()">Save & Subscribe Later</button>
    <button mat-flat-button (click)="onNext()" [disabled]="!isStep1FormValid()"
      [ngClass]="!isStep1FormValid() ? 'e-mat-button e-mat-button--eblue400 eh-csr-dsb' : 'e-mat-button e-mat-button--eblue400'">
      Save & Next
    </button>
  </div>
</ng-container>
<ng-template #dataAwaitedBlk>
  <div class="e-spinner">
    <mat-spinner [diameter]="30" [strokeWidth]="3"></mat-spinner>
  </div>
</ng-template>